/////////////////////ACDFSM by Redphoenix///////////////////////////////////////////////
//////main shader
///////////////////////////////////////////////////////////////////////////////////////////////////////////
//Texture TargetMap;
Texture mtlSkin1;
Texture mtlSkin2;
Texture mtlSkin3;
Texture mtlSkin4;
Texture entSkin1;
Texture depth5_a_bmap;
Texture depth6_a_bmap;

float4x4 matMtl; 	
const float4x4 matWorld;	// World matrix.
const float4x4 matViewProj;	// World matrix.
float4 vecSkill1; //x = depth_bias, y = brightness 
float4 vecSkill5; //x = depth_bias, y = brightness 
float4 vecViewPos;
float4 vecViewDir;


sampler main_map = sampler_state { Texture = <entSkin1>;
   MipFilter = Linear;
    MinFilter = Linear;
    MagFilter = Linear;

   AddressU  = wrap;
AddressV  = wrap;
 };
sampler shadow_map = sampler_state { Texture = <mtlSkin1>;
   MipFilter = Linear;
    MinFilter = Linear;
    MagFilter = Linear;
   
   AddressU  = clamp;
AddressV  = clamp;
 };
sampler shadow2_map = sampler_state { Texture = <mtlSkin2>;
   MipFilter = Linear;
    MinFilter = Linear;
    MagFilter = Linear;
  
   AddressU  = clamp;
AddressV  = clamp;
 };
sampler shadow3_map = sampler_state { Texture = <mtlSkin3>;
   MipFilter = Linear;
    MinFilter = Linear;
    MagFilter = Linear;
  
   AddressU  = clamp;
AddressV  = clamp;
 };
 sampler shadow4_map = sampler_state { Texture = <mtlSkin4>;
   MipFilter = Linear;
    MinFilter = Linear;
    MagFilter = Linear;
 
   AddressU  = clamp;
AddressV  = clamp;
 };
 sampler shadow5_map = sampler_state { Texture = <depth5_a_bmap>;
   MipFilter = Linear;
    MinFilter = Linear;
    MagFilter = Linear;
 
  AddressU  = clamp;
AddressV  = clamp;
 };
 sampler shadow6_map = sampler_state { Texture = <depth6_a_bmap>;
   MipFilter = Linear;
    MinFilter = Linear;
    MagFilter = Linear;
 
   AddressU  = clamp;
AddressV  = clamp;
 }; 
// Vertex Shader
void depthVS (in float4 inPos: POSITION,
		in float4 inTex: TEXCOORD0,
		in float3 inNormal: NORMAL,
		out float4 outPos: POSITION,
		out float4 outTex: TEXCOORD0,
		out float3 outNormal: TEXCOORD1,
		out float4 outDepth: TEXCOORD2,
		out float4 outDepth2: TEXCOORD3,
		out float4 outDepth3: TEXCOORD4,
		out float4 outDepth4: TEXCOORD5,
		out float4 outDepth5: TEXCOORD6,
		out float4 outDepth6: TEXCOORD7)
{
	outPos = mul(mul(inPos,matWorld),matViewProj);
	outNormal = normalize(mul(inNormal,matWorld));
	outTex = inTex;
	float4x4 vmatView;
	//build up matView for every view 
	vmatView[0].xyz = float3(0,0,1); vmatView[0].w = 0.0;
	vmatView[1].xyz = float3(0,1,0); vmatView[1].w = 0.0;
	vmatView[2].xyz = float3(-1,0,0); vmatView[2].w = 0.0;	
	vmatView[3].xyz = float3(vecSkill5.z,-vecSkill5.y,-vecSkill5.x); vmatView[3].w = 1.0;
	outDepth = mul(mul(inPos,matWorld),mul(vmatView,matMtl));
	vmatView[0].xyz = float3(1,0,0); 
	vmatView[1].xyz = float3(0,1,0); 
	vmatView[2].xyz = float3(0,0,1);
	vmatView[3].xyz = float3(-vecSkill5.x,-vecSkill5.y,-vecSkill5.z);		
	outDepth2 = mul(mul(inPos,matWorld),mul(vmatView,matMtl));
	vmatView[0].xyz = float3(0,0,-1); 
	vmatView[1].xyz = float3(0,1,0); 
	vmatView[2].xyz = float3(1,0,0);
	vmatView[3].xyz = float3(-vecSkill5.z,-vecSkill5.y,vecSkill5.x);			
	outDepth3 = mul(mul(inPos,matWorld),mul(vmatView,matMtl));
	vmatView[0].xyz = float3(-1,0,0); 
	vmatView[1].xyz = float3(0,1,0); 
	vmatView[2].xyz = float3(0,0,-1);
	vmatView[3].xyz = float3(vecSkill5.x,-vecSkill5.y,vecSkill5.z);		
	outDepth4 = mul(mul(inPos,matWorld),mul(vmatView,matMtl));
	vmatView[0].xyz = float3(0,-1,0); 
	vmatView[1].xyz = float3(0,0,1); 
	vmatView[2].xyz = float3(-1,0,0);
	vmatView[3].xyz = float3(vecSkill5.z,vecSkill5.x,-vecSkill5.y);		
	outDepth5 = mul(mul(inPos,matWorld),mul(vmatView,matMtl));
	vmatView[0].xyz = float3(0,1,0); 
	vmatView[1].xyz = float3(0,0,-1); 
	vmatView[2].xyz = float3(-1,0,0);
	vmatView[3].xyz = float3(vecSkill5.z,-vecSkill5.x,vecSkill5.y);			
	outDepth6 = mul(mul(inPos,matWorld),mul(vmatView,matMtl));      
	float3 WorldPos  = mul(inPos, matWorld).xyz;
	float  WorldDist = distance(WorldPos.xyz, vecViewPos.xyz);
	outTex.z = saturate(pow(WorldDist/vecSkill1.z,2)-0.5);
	outTex.w = pow(distance(WorldPos.xyz,vecSkill5.xyz)/500,2)-0.2;
}

float4 mainPS(float4 tex : TEXCOORD0, float3 inNormal : TEXCOORD1, float4 shadowCrd : TEXCOORD2, float4 shadowCrd2 : TEXCOORD3, float4 shadowCrd3 : TEXCOORD4, float4 shadowCrd4 : TEXCOORD5, float4 shadowCrd5 : TEXCOORD6, float4 shadowCrd6 : TEXCOORD7) : COLOR
{
	//float d ;//= shadowCrd.z-vecSkill1.x;
	//float d2;
   shadowCrd.xy /= shadowCrd.w;	
   shadowCrd2.xy /= shadowCrd2.w;	
   shadowCrd3.xy /= shadowCrd3.w;	
   shadowCrd4.xy /= shadowCrd4.w;	
   shadowCrd5.xy /= shadowCrd5.w;	
   shadowCrd6.xy /= shadowCrd6.w;	
   float d;
   float alpha = tex2D(main_map,tex.xy).a;
   float4 m;
   if(shadowCrd6.x < 1.0 && shadowCrd6.x > 0 && shadowCrd6.y < 1.0 && shadowCrd6.y > 0 && shadowCrd6.z > 0) { m = tex2D(shadow6_map,shadowCrd6); d = shadowCrd6.z; }
   if(shadowCrd5.x < 1.0 && shadowCrd5.x > 0 && shadowCrd5.y < 1.0 && shadowCrd5.y > 0  && shadowCrd5.z > 0) { m = tex2D(shadow5_map,shadowCrd5); d = shadowCrd5.z;  }  	
	if(shadowCrd4.x < 1.0 && shadowCrd4.x > 0 && shadowCrd4.y < 1.0 && shadowCrd4.y > 0  && shadowCrd4.z > 0) { m = tex2D(shadow4_map,shadowCrd4); d = shadowCrd4.z; }
   if(shadowCrd3.x < 1.0 && shadowCrd3.x > 0 && shadowCrd3.y < 1.0 && shadowCrd3.y > 0  && shadowCrd3.z > 0) { m = tex2D(shadow3_map,shadowCrd3); d = shadowCrd3.z; }
   if(shadowCrd2.x < 1.0 && shadowCrd2.x > 0 && shadowCrd2.y < 1.0 && shadowCrd2.y > 0  && shadowCrd2.z > 0) { m = tex2D(shadow2_map,shadowCrd2); d = shadowCrd2.z;  }
   if(shadowCrd.x < 1.0 && shadowCrd.x > 0 && shadowCrd.y < 1.0 && shadowCrd.y > 0  && shadowCrd.z > 0) { m = tex2D(shadow_map,shadowCrd); d = shadowCrd.z; }
    d = d-vecSkill1.x;
	
	float max_d = m.w + 0.000001;
	float min_d = m.x;
	float t = saturate((d - min_d) / (max_d - min_d));
	float shadow = 1.0-(3*t*pow(1-t,2)*m.y + 3*t*t*(1-t)*m.z +t*t*t);
	shadow = saturate(shadow-tex.w)+vecSkill1.y+tex.z;
   return float4(shadow,shadow,shadow,alpha);
   //return(float4(matEffect3[1].z,matEffect3[0].x,matEffect3[0].x,1));
}


// Technique
technique ShadowMap
{
	pass Pass0
	{
		ZWriteEnable = True;
		AlphaBlendEnable = True;		
		CullMode = CCW;		
		//Lighting = False;
		//AlphaTestEnable = True;
		//AlphaRef = 200;
		
		VertexShader = compile vs_2_0 depthVS();
		PixelShader = compile ps_2_a mainPS();
	}
}